/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedLengthList.h"

#include <wtf/GetPtr.h>

#include "JSSVGLengthList.h"
#include "SVGLengthList.h"

using namespace KJS;

namespace WebCore {

/* Hash table */

static const HashEntry JSSVGAnimatedLengthListTableEntries[] =
{
    { "baseVal", JSSVGAnimatedLengthList::BaseValAttrNum, DontDelete|ReadOnly, 0, 0 },
    { "animVal", JSSVGAnimatedLengthList::AnimValAttrNum, DontDelete|ReadOnly, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthListTable = 
{
    2, 2, JSSVGAnimatedLengthListTableEntries, 2
};

/* Hash table for prototype */

static const HashEntry JSSVGAnimatedLengthListPrototypeTableEntries[] =
{
    { 0, 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthListPrototypeTable = 
{
    2, 1, JSSVGAnimatedLengthListPrototypeTableEntries, 1
};

const ClassInfo JSSVGAnimatedLengthListPrototype::info = { "SVGAnimatedLengthListPrototype", 0, &JSSVGAnimatedLengthListPrototypeTable, 0 };

JSObject* JSSVGAnimatedLengthListPrototype::self(ExecState* exec)
{
    return KJS::cacheGlobalObject<JSSVGAnimatedLengthListPrototype>(exec, "[[JSSVGAnimatedLengthList.prototype]]");
}

const ClassInfo JSSVGAnimatedLengthList::info = { "SVGAnimatedLengthList", 0, &JSSVGAnimatedLengthListTable, 0 };

JSSVGAnimatedLengthList::JSSVGAnimatedLengthList(ExecState* exec, SVGAnimatedLengthList* impl)
    : m_impl(impl)
{
    setPrototype(JSSVGAnimatedLengthListPrototype::self(exec));
}

JSSVGAnimatedLengthList::~JSSVGAnimatedLengthList()
{
    SVGDocumentExtensions::forgetGenericContext<SVGAnimatedLengthList>(m_impl.get());
    ScriptInterpreter::forgetDOMObject(m_impl.get());
}

bool JSSVGAnimatedLengthList::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedLengthList, KJS::DOMObject>(exec, &JSSVGAnimatedLengthListTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedLengthList::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedLengthList* imp = static_cast<SVGAnimatedLengthList*>(impl());

        return toJS(exec, WTF::getPtr(imp->baseVal()));
    }
    case AnimValAttrNum: {
        SVGAnimatedLengthList* imp = static_cast<SVGAnimatedLengthList*>(impl());

        return toJS(exec, WTF::getPtr(imp->animVal()));
    }
    }
    return 0;
}

KJS::JSValue* toJS(KJS::ExecState* exec, SVGAnimatedLengthList* obj)
{
    return KJS::cacheDOMObject<SVGAnimatedLengthList, JSSVGAnimatedLengthList>(exec, obj);
}
SVGAnimatedLengthList* toSVGAnimatedLengthList(KJS::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedLengthList::info) ? static_cast<JSSVGAnimatedLengthList*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
