/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedTransformList.h"

#include <wtf/GetPtr.h>

#include "JSSVGTransformList.h"
#include "SVGTransformList.h"

using namespace KJS;

namespace WebCore {

/* Hash table */

static const HashEntry JSSVGAnimatedTransformListTableEntries[] =
{
    { "baseVal", JSSVGAnimatedTransformList::BaseValAttrNum, DontDelete|ReadOnly, 0, 0 },
    { "animVal", JSSVGAnimatedTransformList::AnimValAttrNum, DontDelete|ReadOnly, 0, 0 }
};

static const HashTable JSSVGAnimatedTransformListTable = 
{
    2, 2, JSSVGAnimatedTransformListTableEntries, 2
};

/* Hash table for prototype */

static const HashEntry JSSVGAnimatedTransformListPrototypeTableEntries[] =
{
    { 0, 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedTransformListPrototypeTable = 
{
    2, 1, JSSVGAnimatedTransformListPrototypeTableEntries, 1
};

const ClassInfo JSSVGAnimatedTransformListPrototype::info = { "SVGAnimatedTransformListPrototype", 0, &JSSVGAnimatedTransformListPrototypeTable, 0 };

JSObject* JSSVGAnimatedTransformListPrototype::self(ExecState* exec)
{
    return KJS::cacheGlobalObject<JSSVGAnimatedTransformListPrototype>(exec, "[[JSSVGAnimatedTransformList.prototype]]");
}

const ClassInfo JSSVGAnimatedTransformList::info = { "SVGAnimatedTransformList", 0, &JSSVGAnimatedTransformListTable, 0 };

JSSVGAnimatedTransformList::JSSVGAnimatedTransformList(ExecState* exec, SVGAnimatedTransformList* impl)
    : m_impl(impl)
{
    setPrototype(JSSVGAnimatedTransformListPrototype::self(exec));
}

JSSVGAnimatedTransformList::~JSSVGAnimatedTransformList()
{
    SVGDocumentExtensions::forgetGenericContext<SVGAnimatedTransformList>(m_impl.get());
    ScriptInterpreter::forgetDOMObject(m_impl.get());
}

bool JSSVGAnimatedTransformList::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedTransformList, KJS::DOMObject>(exec, &JSSVGAnimatedTransformListTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedTransformList::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedTransformList* imp = static_cast<SVGAnimatedTransformList*>(impl());

        return toJS(exec, WTF::getPtr(imp->baseVal()));
    }
    case AnimValAttrNum: {
        SVGAnimatedTransformList* imp = static_cast<SVGAnimatedTransformList*>(impl());

        return toJS(exec, WTF::getPtr(imp->animVal()));
    }
    }
    return 0;
}

KJS::JSValue* toJS(KJS::ExecState* exec, SVGAnimatedTransformList* obj)
{
    return KJS::cacheDOMObject<SVGAnimatedTransformList, JSSVGAnimatedTransformList>(exec, obj);
}
SVGAnimatedTransformList* toSVGAnimatedTransformList(KJS::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedTransformList::info) ? static_cast<JSSVGAnimatedTransformList*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
