/****************************************************************************
**
** Copyright (C) 2007-2007 Trolltech ASA. All rights reserved.
**
** This file is part of the Qt Assistant of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://trolltech.com/products/qt/licenses/licensing/opensource/
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://trolltech.com/products/qt/licenses/licensing/licensingoverview
** or contact the sales department at sales@trolltech.com.
**
** In addition, as a special exception, Trolltech gives you certain
** additional rights. These rights are described in the Trolltech GPL
** Exception version 1.0, which can be found at
** http://www.trolltech.com/products/qt/gplexception/ and in the file
** GPL_EXCEPTION.txt in this package.
**
** In addition, as a special exception, Trolltech, as the sole copyright
** holder for Qt Designer, grants users of the Qt/Eclipse Integration
** plug-in the right for the Qt/Eclipse Integration to link to
** functionality provided by Qt Designer and its related libraries.
**
** Trolltech reserves all rights not expressly granted herein.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef BOOKMARKDIALOG_H
#define BOOKMARKDIALOG_H

#include <QtCore/QString>
#include <QtGui/QDialog>

QT_BEGIN_NAMESPACE

class QWidget;
class QLineEdit;
class QComboBox;
class QToolButton;
class QPushButton;
class QHelpEngine;
class BookmarkWidget;
class QDialogButtonBox;

class BookmarkDialog : public QDialog
{
    Q_OBJECT

public:
    BookmarkDialog(QHelpEngine *engine, const QString &title, 
        const QString &url, QWidget *parent = 0);
    ~BookmarkDialog();

private slots:
    void addAccepted();
    void addNewFolder();
    void toolButtonClicked();
    void textChanged(const QString &text);
    void currentItemChanged(const QString &title);

private:
    QString m_url;
    QString m_title;
    QString m_bookmarks;
    QLineEdit *bookmarkEdit;
    QToolButton *toolButton;
    QHelpEngine *helpEngine;
    QComboBox *bookmarkFolders;
    QDialogButtonBox *buttonBox;
    QPushButton *newFolderButton;
    BookmarkWidget *bookmarkWidget;
};

QT_END_NAMESPACE

#endif // BOOKMARKDIALOG_H
